package de.dfki.km.academicresearch.eswc2016challenge.cameraready;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class Main {
    
    public static void main(String[] args) throws Exception {
        
        DataBasis data = new DataBasis(args[0]);
        
        int task = Integer.parseInt(args[1]);
        switch(task) {
            
            case 0: { 
                ModifiedEppstein modepp = new ModifiedEppstein("http://dbpedia.org/resource/Elliot_Richardson", data);
                PathList a = modepp.find("http://dbpedia.org/resource/1952_Winter_Olympics", 377);
                a.save("task1-part1-377.txt");
                break;
            }
            
            case 1: { 
                ModifiedEppstein modepp = new ModifiedEppstein("http://dbpedia.org/resource/Elliot_Richardson", data);
                PathList b = modepp.find("http://dbpedia.org/resource/1952_Winter_Olympics", 53008);
                b.save("task1-part2-53008.txt");
                break;
            }
            
            case 2: { 
                ModifiedEppsteinBidirectional modeppA = new ModifiedEppsteinBidirectional(
                "http://dbpedia.org/resource/1952_Winter_Olympics", 
                "http://dbpedia.org/resource/Elliot_Richardson", 
                "http://dbpedia.org/property/after", 
                374, 
                data);
        
                PathList a = modeppA.find();
                a.save("task2-part1-374.txt");
                break;
            }
            
            case 3: { 
                ModifiedEppsteinBidirectional modeppA = new ModifiedEppsteinBidirectional(
                "http://dbpedia.org/resource/1952_Winter_Olympics", 
                "http://dbpedia.org/resource/Elliot_Richardson", 
                "http://dbpedia.org/property/after", 
                52664, 
                data);
                
                PathList a = modeppA.find();
                a.save("task2-part2-52664.txt");
                break;
            }
            
        }
    }
    
    
}
