package de.dfki.km.academicresearch.eswc2016challenge.unittests.exampleTestTaskOne;

import de.dfki.km.academicresearch.eswc2016challenge.cameraready.Path;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.PathFinder;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.ExampleDataset;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.PathChooser;
import java.util.List;
import org.apache.jena.riot.system.StreamOps;
import org.apache.jena.riot.system.StreamRDF;
import org.apache.jena.riot.system.StreamRDFLib;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * This is a multigraph example
 *
 * @author Sven
 *
 */
public class ExampleTestsLoops {

    private static final Logger logger = LoggerFactory.getLogger(ExampleTestsLoops.class);

    @Test
    public void testIt() throws Exception {

        for (int i = 1; i <= 10; i++) {

            PathFinder pathFinder = PathChooser.getCurrentPathFinder();
            pathFinder.setIndex("challenge_training_dataset", "datasetLoops" + i);
            StreamRDF streamRDF = StreamRDFLib.sinkTriples(pathFinder);
            pathFinder.startStreaming();
            StreamOps.graphToStream(ExampleDataset.getDataSetLoops(i).getGraph(), streamRDF);

            long expectedpathes = expectedpathes(i);
            
            //we want all
            List<Path> ps = pathFinder.find(ExampleDataset.A.getURI(), ExampleDataset.A.getURI(), (int) expectedpathes, null);
            
            //for 4 edges
            //sum 4! / (4-r)!, r=1 to 4
            
            
            
            //for(Path p : ps) {
            //    logger.debug(p.toString());
            //}
        }
    }
    
    public static long fak(long n) {
        return (n > 1 ? n * fak(n-1) : 1); 
    }
    
    public static long expectedpathes(long n) {
        //sum 4! / (4-r)!, r=1 to 4
        long sum = 0;
        for(long r = 1; r <= n; r++) {
            sum += (fak(n) / fak(n - r));
        }
        return sum;
    }

    
}
